;  enter.ash -- assembler stuff
;
;  This file is part of the UCL real-time data compression library.
;
;  Copyright (C) 2000 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1999 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1998 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1997 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1996 Markus Franz Xaver Johannes Oberhumer
;
;  The UCL library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU General Public License as
;  published by the Free Software Foundation; either version 2 of
;  the License, or (at your option) any later version.
;
;  The UCL library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with the UCL library; see the file COPYING.
;  If not, write to the Free Software Foundation, Inc.,
;  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;
;  Markus F.X.J. Oberhumer
;  markus.oberhumer@jk.uni-linz.ac.at
;


; /***********************************************************************
; //
; ************************************************************************/

                push_cregs

%define IN      dword [esp + cregs_size + 4]
%define IN_LEN  dword [esp + cregs_size + 8]
%define OUT     dword [esp + cregs_size + 12]
%define OUT_LEN dword [esp + cregs_size + 16]

                cld
                mov     esi, IN
                mov     edi, OUT


%ifdef UCL_SAFE
  %define OUT_END dword [esp - 4]
                mov     eax, edi
                mov     edx, OUT_LEN
                add     eax, [edx]
                jc      near L_error
                mov     OUT_END, eax

  %define IN_END dword [esp - 8]
                mov     eax, esi
                add     eax, IN_LEN
                jc      near L_error
                mov     IN_END, eax

  %ifdef UCL_BB
    %if (UCL_BB == 16)
      %define IN_END2 dword [esp - 12]
                sub     eax, byte 2
                jc      near L_input_overrun
                cmp     eax, esi
                jb      near L_input_overrun
                mov     IN_END2, eax
    %elif (UCL_BB == 32)
      %define IN_END4 dword [esp - 12]
                sub     eax, byte 4
                jc      near L_input_overrun
                cmp     eax, esi
                jb      near L_input_overrun
                mov     IN_END4, eax
    %endif
  %endif ; ifdef UCL_BB
%endif


; vi:ts=8:et

