;  leave.ash -- assembler stuff
;
;  This file is part of the UCL real-time data compression library.
;
;  Copyright (C) 2000 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1999 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1998 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1997 Markus Franz Xaver Johannes Oberhumer
;  Copyright (C) 1996 Markus Franz Xaver Johannes Oberhumer
;
;  The UCL library is free software; you can redistribute it and/or
;  modify it under the terms of the GNU General Public License as
;  published by the Free Software Foundation; either version 2 of
;  the License, or (at your option) any later version.
;
;  The UCL library is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with the UCL library; see the file COPYING.
;  If not, write to the Free Software Foundation, Inc.,
;  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;
;  Markus F.X.J. Oberhumer
;  markus.oberhumer@jk.uni-linz.ac.at
;


; /***********************************************************************
; //
; ************************************************************************/

; check uncompressed size
%ifdef UCL_SAFE
                cmp     edi, OUT_END
                ja      L_output_overrun
%endif

;  check compressed size
                mov     edx, IN
                add     edx, IN_LEN
                cmp     esi, edx
                ja      L_input_overrun
                jb      L_input_not_consumed

L_leave:
                sub     edi ,OUT        ; write back the uncompressed size
                mov     edx, OUT_LEN
                mov     [edx], edi

                pop_cregs
                ret


L_error:
                SET_REG eax, -1         ; UCL_E_ERROR
                jmps    L_leave

L_input_not_consumed:
                SET_REG eax, -205       ; UCL_E_INPUT_NOT_CONSUMED
                jmps    L_leave

L_input_overrun:
                SET_REG eax, -201       ; UCL_E_INPUT_OVERRUN
                jmps    L_leave

%ifdef UCL_SAFE
L_output_overrun:
                SET_REG eax, -202       ; UCL_E_OUTPUT_OVERRUN
                jmps    L_leave

L_lookbehind_overrun:
                SET_REG eax, -203       ; UCL_E_LOOKBEHIND_OVERRUN
                jmps    L_leave
%endif

%ifdef UCL_DEBUG
L_assert_fail:
                SET_REG eax, -99
                jmps    L_leave
%endif


; vi:ts=8:et

